#ifndef Analysis_h 
#define Analysis_h
/*****************************************************************************
 * Copyright (C) 2009-2016    this file is part of the NPTool Project        *
 *                                                                           *
 * For the licensing terms see $NPTOOL/Licence/NPTool_Licence                *
 * For the list of contributors see $NPTOOL/Licence/Contributors             *
 *****************************************************************************/

/*****************************************************************************
 * Original Author: XAUTHORX  contact address: XMAILX                        *
 *                                                                           *
 * Creation Date  : XMONTHX XYEARX                                           *
 * Last update    :                                                          *
 *---------------------------------------------------------------------------*
 * Decription:                                                               *
 *  This class describe  Vendeta analysis project                       *
 *                                                                           *
 *---------------------------------------------------------------------------*
 * Comment:                                                                  *
 *                                                                           *
 *****************************************************************************/

#include"NPVAnalysis.h"
#include"TVendetaPhysics.h"
#include"TFissionChamberPhysics.h"
#include "NPParticle.h"
#include "TRandom3.h"

class Analysis: public NPL::VAnalysis{
  public:
    Analysis();
    ~Analysis();

  public: 
    void Init();
    void TreatEvent();
    void End();
    void InitOutputBranch();
    void ReInitValue();

   static NPL::VAnalysis* Construct();

  private:
   vector<double> ThetaLab;
   vector<double> ELab;
   vector<double> Tof;
   vector<double> Charge;

  private:
   TVendetaPhysics* Vendeta;
   TFissionChamberPhysics* FC;

   NPL::Particle* neutron;
   TRandom3 ra;
};
#endif
